package crafttweaker.mc1120.actions;

import crafttweaker.*;
import net.minecraft.block.Block;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;

/**
 * @author Jared
 */
public class ActionSetBlockHardness implements IAction {

    private final ItemStack stack;
    private final float hardness;
    
    public ActionSetBlockHardness(ItemStack stack, float hardness) {
        this.stack = stack;
        this.hardness = hardness;
    }

    private static void set(ItemStack stack, float hardness) {
        if(isBlock(stack)) {
            Block block = Block.func_149634_a(stack.func_77973_b());
            block.func_149711_c(hardness);
        } else {
            CraftTweakerAPI.logError("Item is not a block");
        }
    }

    public static boolean isBlock(ItemStack stack) {
        if(stack.func_190926_b()) {
            return false;
        }
        ResourceLocation name = Block.field_149771_c.func_177774_c(Block.func_149634_a(stack.func_77973_b()));
        return !name.toString().equals("minecraft:air") && Block.field_149771_c.func_148741_d(name);

    }

    @Override
    public void apply() {
        if(isBlock(stack)) {
            set(stack, hardness);
        }
    }


    @Override
    public String describe() {
        if(isBlock(stack)) {
            return "Setting hardness of " + stack.func_82833_r() + " to " + hardness;
        }
        return "Unable to set hardness of " + stack.func_82833_r() + " because it is an Item";
    }
}
