package crafttweaker.mc1120.vanilla;

import crafttweaker.CraftTweakerAPI;
import crafttweaker.api.item.*;
import crafttweaker.api.minecraft.CraftTweakerMC;
import crafttweaker.api.vanilla.ISeedRegistry;
import crafttweaker.mc1120.actions.*;
import crafttweaker.mc1120.util.CraftTweakerHacks;
import net.minecraft.util.WeightedRandom;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @author Stan
 */
public class MCSeedRegistry implements ISeedRegistry {
    
    public static final List SEEDS = CraftTweakerHacks.getSeeds();
    
    @Override
    public void addSeed(WeightedItemStack item) {
        CraftTweakerAPI.apply(new ActionAddSeed(item));
    }
    
    @Override
    public void removeSeed(IIngredient pattern) {
        CraftTweakerAPI.apply(new ActionRemoveSeed(pattern));
    }
    
    @Override
    public List<WeightedItemStack> getSeeds() {
        List<? extends WeightedRandom.Item> entries = (List<? extends WeightedRandom.Item>) SEEDS;
        
        return entries.stream().map(entry -> new WeightedItemStack(CraftTweakerMC.getIItemStack(CraftTweakerHacks.getSeedEntrySeed(entry)), entry.field_76292_a)).collect(Collectors.toList());
    }
}
